;;;; url-test.scm

(use testbase testbase-output-human)
(use url)

#| TestBase
  (test
    (purpose "Checkout url build.")
    (feature url)
    (reader-extension uri))

  (compile
    (extend (use uri)))
|#

;;;

(define-test url-test "URL"
  (initial
    (define turl #f)
  )

  (expect-set! turl (url "http://www.ics.uci.edu:80"))
  (expect-false "Null path" (url-path turl))

  (expect-set! turl
    (make-url #:scheme "http" #:host "www.ics.uci.edu" #:port 80 #:path "pub/ietf/uri"))
  (expect-true (url? turl))
  (expect-equal "http://www.ics.uci.edu:80/pub/ietf/uri" (url->string turl))

  (expect-set! turl (url "http://www.ics.uci.edu:80/pub/ietf/uri;type=i"))
  (expect-true (url? turl))

  (expect-equal (warn "Suffix '/' in output was not part of the input!")
    "http://www.ics.uci.edu:80/pub/ietf/uri/;type=i"
    (url->string (url "http://www.ics.uci.edu:80/pub/ietf/uri;type=i")))
  (expect-eq #\i (url-typecode turl))
)

(test::styler-set! url-test test::output-style-human)
(run-test "URL Tests")
